


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    set ServiceList [list NetVarService VMEAccessServer]
    variable ServiceName [lindex $ServiceList 0]

    set RegName "*"
    set RegAttr ""
    set RegData 0

    variable RegisterList [list NULL]

    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag

       variable RegName 
       variable RegAttr
       variable RegData       
       variable ServiceName

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
         InsertLog "RegName=$RegName; RegAttr=$RegAttr; RegData=$RegData"
         InsertLog "ServiceName=$ServiceName"
    }

   proc do_create {} {
       variable RegName
       variable RegAttr
       global errorCode errorInfo
       variable ServiceName

       set z [catch {::namespace inscope ::urn:$ServiceName DefineRegister  $RegName NetVar "$RegAttr"} msg]

       if {$z == 0} {
           InsertLog "DefineRegister returned: [lindex $msg 5]"
       } else {
           InsertLog "DefineRegister failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_inquire {} {
       variable RegName
       global errorCode errorInfo
       variable ServiceName
       variable RegisterList

       set z [catch {::namespace inscope ::urn:$ServiceName InquireRegisters $RegName} msg]

       if {$z == 0} {
           InsertLog "InquireRegisters returned:"
           set RegisterList {}
           foreach item [lindex $msg 5] {lappend RegisterList $item; InsertLog "$item"}
       } else {
           InsertLog "InquireRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_delete {} {
       variable RegName 
       global errorCode errorInfo
       variable ServiceName

       set z [catch {::namespace inscope ::urn:$ServiceName DeleteRegisters $RegName} msg]

       if {$z == 0} {
           InsertLog "DeleteRegisters returned: [lindex $msg 5]"
       } else {
           InsertLog "DeleteRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_read {} {
       variable RegName
       global errorCode errorInfo
       variable ServiceName
       variable RegData

       set z [catch {::namespace inscope ::urn:$ServiceName ReadRegisters $RegName} msg]

       if {$z == 0} {
           InsertLog "ReadRegisters returned: [lindex $msg 5]"
           set RegData [second [first [lindex $msg 5]]]
       } else {
           InsertLog "ReadRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_write {} {
       variable RegName 
       variable RegData
       global errorCode errorInfo
       variable ServiceName

       set z [catch {::namespace inscope ::urn:$ServiceName WriteRegisters $RegName [list $RegData]} msg]

       if {$z == 0} {
           InsertLog "WriteRegisters returned: [lindex $msg 5]"
       } else {
           InsertLog "WriteRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_readattributes {} {
       variable RegName
       global errorCode errorInfo       
       variable ServiceName
       variable RegAttr

       set z [catch {::namespace inscope ::urn:$ServiceName ReadRegistersAttributes $RegName} msg]

       if {$z == 0} {
           InsertLog "ReadRegistersAttributes returned: [lindex $msg 5]"
           set RegAttr [second [first [lindex $msg 5]]]
       } else {
           InsertLog "ReadRegistersAttributes failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_writeattributes {} {
       variable RegName 
       variable RegAttr
       global errorCode errorInfo
       variable ServiceName

       set z [catch {::namespace inscope ::urn:$ServiceName WriteRegistersAttributes $RegName "$RegAttr"} msg]

       if {$z == 0} {
           InsertLog "WriteRegistersAttributes returned: [lindex $msg 5]"
       } else {
           InsertLog "WriteRegistersAttributes failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS

       variable RegName 
       variable RegAttr
       variable RegData

       variable ServiceName

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

            VERBOSE  {set Verbose [expr ($Verbose + 1) & 1]}

            CREATE   {do_create}
            DELETE   {do_delete}
            WRITEATTR  {do_writeattributes}
            READATTR   {do_readattributes}
            READ     {do_read}
            WRITE    {do_write}

            QUERY    {do_inquire}

            REGNAME {set RegName [lindex $w 1]}
            REGATTR {set RegAttr [lindex $w 1]}
            REGDATA {set RegData [lindex $w 1]}

            SERVICENAME {set ServiceName [lindex $w 1]}
            REGNAMES    {set RegName [lindex $w 1]}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
    }

}   ;# end of if {$started == 0}



